using namespace std;

#include <unordered_set>
#include <queue>
#include "testlib.h"

int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);

    int max_n = opt<int>("n");
    int max_m = opt<int>("m");
    double rc = has_opt("r") ? opt<double>("r") : 0.85;
    bool oner = has_opt("oner") && opt<bool>("oner");
    double chw = has_opt("w") ? opt<double>("w") : 0.75;

    int n = 1 + rnd.wnext(max_n, 3);
    int m = 1 + rnd.wnext((int) min((long long) max_m, (long long) n * ((long long) n - 1) / 2 + 1), 3);

    vector<int> colors(n);
    vector <vector<int>> parts(3);
    for (int i = 0; i < n; ++i) {
        colors[i] = rnd.next(1, 2);
        parts[colors[i]].push_back(i);
    }

    vector <pair<int, int>> edges;
    set <pair<int, int>> was_eds;
    m = (int) min((long long) m, (long long) parts[1].size() * (long long) parts[2].size());
    for (int i = 0; i < m; ++i) {
        while (true) {
            int u = parts[1][rnd.next(parts[1].size())];
            int v = parts[2][rnd.next(parts[2].size())];
            if (was_eds.find(make_pair(u, v)) != was_eds.end()) {
                continue;
            }
            edges.emplace_back(u, v);
            was_eds.emplace(u, v);
            break;
        }
    }

    vector<int> r(n);
    if (oner) {
        r[rnd.next(0, n - 1)] = 1;
    } else {
        for (int i = 0; i < n; ++i) {
            r[i] = rnd.next() < rc; // 0 < 0 -> false
        }
    }
    for (int i = 0; i < n; ++i) {
        if (r[i]) {
            colors[i] = rnd.next() < chw ? 3 - colors[i] : colors[i];
        }
    }


    printf("%d %d\n", n, m);
    for (int i = 0; i < n; ++i) {
        if (i > 0) { printf(" "); }
        printf("%d", colors[i]);
    }
    printf("\n");
    for (int i = 0; i < n; ++i) {
        if (i > 0) { printf(" "); }
        printf("%d", r[i]);
    }
    printf("\n");

    for (int i = 0; i < m; ++i) {
        if (rnd.next(0, 1)) {
            printf("%d %d\n", edges[i].second + 1, edges[i].first + 1);
        } else {
            printf("%d %d\n", edges[i].first + 1, edges[i].second + 1);
        }
    }
}

