#include "testlib.h"
#include <numeric>

using namespace std;

int main(int argc, char *argv[]) {

    registerGen(argc, argv, 1);
    int n = opt<int>("n"), deg = opt<int>("deg"), l = opt<int>("l");
    int k = has_opt("k") ? opt<int>("k") : 3;

    vector<int> p(n);
    vector<vector<int>> layers(l);
    layers[0].push_back(0);
    int layer_size = (n - 1) / (l - 1);
    for (int layer = 1; layer < l; layer++) {
        int start = layers[layer - 1].back() + 1;
        shuffle(layers[layer - 1].begin(), layers[layer - 1].end());
        int rem = min((int) layers[layer - 1].size(), (layer_size + deg - 1) / deg * 4 / 3);
        for (int cnt = 0; cnt < layer_size && start < n; cnt++, start++) {
            layers[layer].push_back(start);
            p[start] = layers[layer - 1][rnd.next(0, rem - 1)] + 1;
        }
        if (start == n) break;
    }

    int s = layers.back().back() + 1;
    println(s, k);
    println(p.begin() + 1, p.begin() + s);

}