#include <iostream>
#include <vector>
#include <queue>
#include <map>
#include <set>
#include <numeric>
#include <algorithm>

using namespace std;

typedef long long ll;

const ll MOD = 1e9 + 7;

void go(int v, vector<vector<int>> &g, vector<ll> &dp1, vector<ll> &dp2, int p = -1) {
    if (p != -1 && g[v].size() == 1) {
        dp1[v] = 1;
        return;
    }
    vector<ll> dps;
    ll x2 = 0;
    vector<int> I;
    for (int u: g[v]) {
        if (u == p) {
            continue;
        }
        go(u, g, dp1, dp2, v);
        I.push_back(u);
        dp2[v] = (dp2[v] * dp1[u]) % MOD;
    }
    int m = I.size();
    for (int i = 0; i < m; ++i) {
        for (int j = i + 1; j < m; ++j) {
            ll add = (dp2[I[i]] * dp2[I[j]]) % MOD;
            for (int k = 0; k < m; ++k) {
                if (k != i && k != j) {
                    add = (add * dp1[I[k]]) % MOD;
                }
            }
            x2 = (x2 + add) % MOD;
        }
    }
    dp1[v] = (dp2[v] + x2) % MOD;
}

void solve() {
    int n, k;
    cin >> n >> k;
    vector<vector<int>> g(n);
    for (int i = 1; i < n; ++i) {
        int p;
        cin >> p;
        p--;
        g[i].push_back(p), g[p].push_back(i);
    }
    vector<ll> dp1(n), dp2(n, 1);
    go(0, g, dp1, dp2);
    cout << dp1[0] << '\n';
}

bool multitest = false;

int main() {
    int t = 1;
    if (multitest) {
        cin >> t;
    }
    for (int i = 0; i < t; ++i) {
        solve();
    }
}